<ng-container *ngIf="{
         categories: categories$ | async,
         competitions: competitions$ | async,
         divisions: divisions$ | async,
         groups: groups$ | async,
         screenSize: screenSize$ | async,
         dateStartAt: dateStartAt$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.day.edit.seo.' + mode.toString().toLocaleLowerCase() + '.title' | translate }}
      </h1>
      <p>
        {{ 'admin.day.edit.seo.' + mode.toString().toLocaleLowerCase() + '.description' | translate }}
      </p>
      <form [formGroup]="formGroup"
            #form="ngForm" (ngSubmit)="formGroup.valid && save()">
        <mat-form-field>
          <mat-label>
            {{ 'admin.day.edit.form.category' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.category"
                            [control]="formGroup.controls.category"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="category"
                        (selectionChange)="categoryChange()">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.category.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.day.edit.form.competition' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.competition"
                            [control]="formGroup.controls.competition"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="competition"
                        (selectionChange)="competitionChange()">
              <mat-option *ngFor="let competition of vm.competitions?.items; trackBy: trackBySlug"
                          [value]="competition.slug">
                {{ competition.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.competition.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.day.edit.form.division' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.division"
                            [control]="formGroup.controls.division"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="division"
                        (selectionChange)="divisionChange()">
              <mat-option *ngFor="let division of vm.divisions?.items; trackBy: trackBySlug"
                          [value]="division.slug">
                {{ division.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.division.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.day.edit.form.group' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.group"
                            [control]="formGroup.controls.group"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="group">
              <mat-option *ngFor="let group of vm.groups?.items; trackBy: trackBySlug"
                          [value]="group.slug">
                {{ group.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.group.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.day.edit.form.index' | translate }}
          </mat-label>
          <input matInput type="number"
                 name="index" formControlName="index" [min]="1" />
          <mat-error *ngIf="formGroup.controls.index.errors?.unicity">
            {{ 'admin.common.validation.unicity' | translate:{ value: formGroup.controls.index.errors?.unicity?.current } }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.index.errors?.min">
            {{ 'admin.common.validation.min' | translate:{ min: formGroup.controls.index.errors?.min?.min } }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.index.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.day.edit.form.date' | translate }}
          </mat-label>
          <input matInput name="date" formControlName="date"
                 [matDatepicker]="datePicker">
          <mat-datepicker-toggle [for]="datePicker" matSuffix></mat-datepicker-toggle>
          <mat-datepicker #datePicker [startAt]="formGroup.value.date || vm.dateStartAt"></mat-datepicker>
          <mat-error *ngIf="formGroup.controls.date.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>
      </form>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-stroked-button color="accent"
         [routerLink]="previousRouteCommands?.commands"
         [queryParams]="previousRouteCommands?.queryParams">
        <mat-icon>
          cancel
        </mat-icon>
        {{ 'admin.common.action.cancel' | translate }}
      </a>
      <app-async-button [loading]="loading.save">
        <button mat-flat-button color="primary" (click)="form.onSubmit($event)">
          <mat-icon>
            save
          </mat-icon>
          {{ 'admin.common.action.save' | translate }}
        </button>
      </app-async-button>
    </ng-container>
  </app-page-form>
</ng-container>
